/********************************************************************************
  $Header: /home/farin/cvs/libvideocoding/libvideocoding/mpeg2/syntax/sliceconf.hh,v 1.3 2002/05/09 22:00:31 farin Exp $

    Slice configuration.
 ********************************************************************************
    Copyright (C) 2001 Dirk Farin (see the README for complete list of authors)

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef LIBVIDEOCODING_MPEG2_SYNTAX_SLICECONF_HH
#define LIBVIDEOCODING_MPEG2_SYNTAX_SLICECONF_HH

#include <libvideogfx/types.hh>

namespace videocoding {

  class MP2_SliceConfiguration
  {
  public:
    virtual ~MP2_SliceConfiguration() { }

    void SetSizeInMBs(int width_mb,int height_mb) { d_width = width_mb; d_height = height_mb; }

    virtual bool IsFirstInSlice(int y,int x) const = 0;
    virtual bool IsLastInSlice (int y,int x) const = 0;

  protected:
    int d_width;
    int d_height;
  };


  // Configuration with the complete picture being in a single slice.
  class MP2_SliceConfiguration_SingleSlice : public MP2_SliceConfiguration
  {
  public:
    bool IsFirstInSlice(int y,int x) const { return x==0 && y==0; }
    bool IsLastInSlice (int y,int x) const { return x==d_width-1 && y==d_height-1; }
  };


  // Configuration with each macroblock row being a separate slice.
  class MP2_SliceConfiguration_RowSlices : public MP2_SliceConfiguration
  {
  public:
    bool IsFirstInSlice(int y,int x) const { return x==0; }
    bool IsLastInSlice (int y,int x) const { return x==d_width-1; }
  };

}

#endif
